import { getStoreBuilder } from 'vuex-typex'
import { RootState } from '@/store/store'

export interface UIState {
  sideBarCollapsed: boolean
  darkMode: boolean
  darkModeUnlocked: boolean
  showJumbotron: boolean
}

function initialState (): UIState {
  return {
    sideBarCollapsed: false,
    darkMode: false,
    darkModeUnlocked: false,
    showJumbotron: true
  }
}

const mb = getStoreBuilder<RootState>().module('UI', initialState())

const stateGetter = mb.state()

function SET_SIDEBAR_COLLAPSED (state: UIState, collapsed: boolean) {
  state.sideBarCollapsed = collapsed
}
function SET_DARK_MODE (state: UIState, val: boolean) {
  state.darkMode = val
}
function SET_DARK_MODE_UNLOCKED (state: UIState, val: boolean) {
  state.darkModeUnlocked = val
}
function SET_SHOW_JUMBOTRON (state: UIState, val: boolean) {
  state.showJumbotron = val
}

export const UI = {
  get state () { return stateGetter() },

  SET_SIDEBAR_COLLAPSED: mb.commit(SET_SIDEBAR_COLLAPSED),
  SET_DARK_MODE: mb.commit(SET_DARK_MODE),
  SET_DARK_MODE_UNLOCKED: mb.commit(SET_DARK_MODE_UNLOCKED),
  SET_SHOW_JUMBOTRON: mb.commit(SET_SHOW_JUMBOTRON)
}
