import { StudentExportItem, InstanceExportData } from '@/api'

export class FakeFileReader {
  result: String = 'Grady testUtils fake result'

  constructor () {}
  // readAsText will execute the callback that was provided to onload
  readAsText (file: File) { this.onload({ target: this }) }
  onload: Function = () => { }
}

export default {
  studentExports: <StudentExportItem[]> [{
    Matrikel: '1000000',
    Name: 'name',
    Username: 'username',
    Sum: 100,
    Exam: 'exam',
    Password: 'pwd',
    Scores: [{ type: 'test01', score: 100 }]
  }],
  studentExportsObfuscated: <StudentExportItem[]> [{
    Matrikel: 'username',
    Name: 'name',
    Username: 'username',
    Sum: 100,
    Exam: 'exam',
    Password: 'pwd',
    Scores: [{ type: 'test01', score: 100 }]
  }],
  instanceExports: <InstanceExportData> {
    students: [{
      name: 'name',
      matrikelNo: '1000000'
    }]
  },
  instanceExportsObfuscated: <InstanceExportData> {
    students: [{
      name: 'name',
      matrikelNo: 'username'
    }]
  },
  fakeFile: <File> {
    lastModified: 1,
    name: 'Grady testUtils fake file',
    size: 1,
    slice: (start?: number | undefined, end?: number | undefined, contentType?: string | undefined): Blob => { return new Blob() },
    type: 'fake file'
  },
  studentMap: {
    'username': {
      matrikelNo: '1000000', name: 'name'
    }
  },
}
